//+------------------------------------------------------------------+
//|                                           Heiken Ashi Arrows.mq4 |
//|                      Copyright 2016, ACB Forex Trading Solutions |
//|                                  https://www.acbforextrading.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, ACB Forex Trading Solutions"
#property link      "https://www.acbforextrading.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LawnGreen
#property indicator_color2 Red
#property indicator_width1 3
#property indicator_width2 3
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
extern int Distance_Arrows = 20;
extern string O1 ="--------------------------------------------------";  
extern string O2 ="Alerts";  
extern bool PopUpAlert = true;    //Popup Alert
extern bool EmailAlert = true;   //Email Alert
extern bool PushAlert  = true;  //Push Notifications Alert
extern string O3 ="--------------------------------------------------";  
extern string O4 ="Heiken Ashi Smothed";  
extern int MaMetod =2;
extern int MaPeriod=3;
extern int MaMetod2 =2;
extern int MaPeriod2=4;
extern string O5 ="--------------------------------------------------";  
extern bool  MA_On_Off  = true;
extern string O6 =" MA1 ";  
extern int MAPeriod1=3;
extern int MA_shift1=0;
extern int MA_method1=MODE_SMA;
extern int Applied_price1=PRICE_CLOSE;
extern string O7 = "MA2 "; 
extern int MAPeriod2=5;
extern int MA_shift2=0;
extern int MA_method2=MODE_SMA;
extern int Applied_price2=PRICE_CLOSE;

// UP and DOWN Buffers
double UP[];
double DOWN[];
// Distance_Arrows of arrows from the high or low of a bar

///////////
int ct=0;
double MyPoint;
datetime CTime;

int OnInit()
  {
//--- indicator buffers mapping
  //UP Arrow Buffer
  SetIndexEmptyValue(0,0.0);
  SetIndexStyle(0,DRAW_ARROW,0,EMPTY);
  SetIndexArrow(0,233);
  SetIndexBuffer(0,UP);
  
  //DOWN Arrow Buffer
  SetIndexEmptyValue(1,0.0);
  SetIndexStyle(1,DRAW_ARROW,0,EMPTY);
  SetIndexArrow(1,234);
  SetIndexBuffer(1,DOWN);
  
  //Auto Adjustment for broker digits
  if (Digits()==5||Digits()==3){MyPoint=Point*10;} else{MyPoint=Point;}
  CTime=Time[0];
 //---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
 int limit = rates_total;
 int count=prev_calculated;
 //Main function
 for(int i=limit-count; i>=1;i--)
 {
 //Getting Heiken Ashi buffer values using the iCustom function
  double SH1 = iCustom(NULL,0,"HPT - Heiken Ashi Smoothed",MaMetod,MaPeriod,MaMetod2,MaPeriod2,0,i);
  double BH1 = iCustom(NULL,0,"HPT - Heiken Ashi Smoothed",MaMetod,MaPeriod,MaMetod2,MaPeriod2,1,i);
  double SH2 = iCustom(NULL,0,"HPT - Heiken Ashi Smoothed",MaMetod,MaPeriod,MaMetod2,MaPeriod2,2,i);
  double BH2 = iCustom(NULL,0,"HPT - Heiken Ashi Smoothed",MaMetod,MaPeriod,MaMetod2,MaPeriod2,3,i);

   if (   MA_On_Off==true  )   {   
      double MA1=iMA(NULL,NULL,MAPeriod1,MA_shift1,MA_method1,Applied_price1,i) ; 
      double MA2=iMA(NULL,NULL,MAPeriod2,MA_shift1,MA_method1,Applied_price1,i) ; 


  if(SH1<BH1 && SH2<BH2 && MA1>MA2 && ct==0)
  {
   UP[i]=Low[i]-Distance_Arrows*MyPoint;ct=1;
   if(CTime!=Time[0])
    {
     if(PopUpAlert){Alert(Symbol()," ","Buy Arrow");}
     if(EmailAlert){SendMail(Symbol()+"Buy Arrow"+"","Buy Signal");}
     if(PushAlert){SendNotification(Symbol()+"Buy Arrow"+"");}
     CTime=Time[0];
    }
  }
  if(SH1>BH1 && SH2>BH2 && MA1<MA2 && ct==1)
  {
   DOWN[i]=High[i]+Distance_Arrows*MyPoint;ct=0;
   if(CTime!=Time[0])
    {
     if(PopUpAlert){Alert(Symbol()," ","Sell Arrow");}
     if(EmailAlert){SendMail(Symbol()+"Sell Arrow"+"","Sell Signal");}
     if(PushAlert){SendNotification(Symbol()+"Sell Arrow"+"");}
     CTime=Time[0];
    }
  } 
  }  
  
   if (   MA_On_Off==false  )   {   


  if(SH1<BH1 && SH2<BH2 &&  ct==0)
  {
   UP[i]=Low[i]-Distance_Arrows*MyPoint;ct=1;
   if(CTime!=Time[0])
    {
     if(PopUpAlert){Alert(Symbol()," ","Buy Arrow");}
     if(EmailAlert){SendMail(Symbol()+"Buy Arrow"+"","Buy Signal");}
     if(PushAlert){SendNotification(Symbol()+"Buy Arrow"+"");}
     CTime=Time[0];
    }
  }
  if(SH1>BH1 && SH2>BH2 &&  ct==1)
  {
   DOWN[i]=High[i]+Distance_Arrows*MyPoint;ct=0;
   if(CTime!=Time[0])
    {
     if(PopUpAlert){Alert(Symbol()," ","Sell Arrow");}
     if(EmailAlert){SendMail(Symbol()+"Sell Arrow"+"","Sell Signal");}
     if(PushAlert){SendNotification(Symbol()+"Sell Arrow"+"");}
     CTime=Time[0];
    }
  } 
  }   
  
  
  
  
  
 } 
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
